;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Structured Exception Handling
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
;##########################################################################
WndProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle	db		"Structured Exception Handling", 0
	szMsgAbout	db		"Structured Exception Handling", 13, 10
			db		"Version 1.0", 13, 10, 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"IRC: #coders on EFnet", 0
	szMenuAbout	db		"&About SEH...", 0

	szZeroDiv	db		"Integer Divide By Zero", 0
	szBreakpoint	db		"Breakpoint (int 3)", 0
	szError		db		"Error", 0
	szErrorThread	db		"Thread Handler", 13, 10, "Exception at %08X", 13, 10, "Recovering...", 0
	szErrorFinal	db		"Final Handler", 13, 10, "Exception at %08X", 13, 10, "Terminating...", 0
	szHandled	db		"Exception handled successfully.", 0
;##########################################################################
.data
;##########################################################################
.data?
	hIcon		dd		?
	szMessage	db		256 dup (?)

	data_start	equ		$
	mbp		MSGBOXPARAMS	<>
	seh		dd		3 dup (?)
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, 0
	mov	[mbp.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR WndProc, eax
	invoke	ExitProcess, eax
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		mov	eax, [hWnd]
		mov	[mbp.hwndOwner], eax
		invoke	GetSystemMenu, eax, 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu
		invoke	LoadIcon, [lParam], 2
		mov	[hIcon], eax
		invoke	SendMessage, [hWnd], WM_SETICON, 1, eax
		invoke	SendDlgItemMessage, [hWnd], 102, CB_ADDSTRING, 0, ADDR szZeroDiv
		invoke	SendDlgItemMessage, [hWnd], 102, CB_SETITEMDATA, eax, EXCEPTION_INT_DIVIDE_BY_ZERO
		invoke	SendDlgItemMessage, [hWnd], 102, CB_ADDSTRING, 0, ADDR szBreakpoint
		invoke	SendDlgItemMessage, [hWnd], 102, CB_SETCURSEL, eax, 0

		; install the final exceptino handler
		invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	.elseif [uMsg]==WM_SYSCOMMAND
		cmp	[wParam], 10
		je	@@msga
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==104
			invoke	SendDlgItemMessage, [hWnd], 102, CB_GETCURSEL, 0, 0
			invoke	SendDlgItemMessage, [hWnd], 102, CB_GETITEMDATA, eax, 0

			; install the per-thread exception handler
			assume	fs:nothing
			push	OFFSET ErrorHandler
			push	FS:[0]
			mov	[seh], esp
			mov	[seh+4], ebp
			mov	[seh+8], OFFSET @@safe
			mov	FS:[0], esp

			test	eax, eax
			.if zero?
				int	3h
			.else
				xor	ecx, ecx
				invoke	RaiseException, eax, ecx, ecx, ecx
			.endif

		@@safe:	pop	FS:[0]		; uninstall the handler
			add	esp, 4

			invoke	MessageBox, [hWnd], ADDR szHandled, ADDR szAppTitle, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
		.elseif ax==105
		@@msga:	mov	[mbp.cbSize], sizeof mbp
			mov	[mbp.lpszText], OFFSET szMsgAbout
			mov	[mbp.lpszCaption], OFFSET szAppTitle
			mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
			mov	[mbp.lpszIcon], 2
			invoke	MessageBoxIndirect, ADDR mbp
		.elseif ax==106
			invoke	SendMessage, [hWnd], WM_CLOSE, 0, 0
		.endif
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
		invoke	DestroyIcon, [hIcon]
	.endif
	xor	eax, eax
	ret
WndProc endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	; message about the exception
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	; the standard way to recover
	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEip], [seh+8]

	; another way to recover
	;mov	esp, [seh]
	;mov	ebp, [seh+4]
	;jmp	[seh+8]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	; note: EXCEPTION_RECORD contains a pointer to the next EXCEPTION_RECORD
	;       structure named pExceptionRecord. The real address of the exception
	;       in your application will be somewhere in the chain.
	;       This piece of code will merely tell the address of the topmost
	;       EXCEPTION_RECORD in the chain.
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	; clean-up and quit
	invoke	EndDialog, [mbp.hwndOwner], eax
	invoke	DestroyIcon, [hIcon]
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start